import treemap.*;
import java.util.Calendar;

Treemap map;
MapLayout layoutAlgorithm = new SquarifiedLayout();

int maxFontSize = 100;
int minFontSize = 10;

PFont font, font2;

int[] frequency = new int[800];
int totalCheckouts;

String dataFile = "query/700s_2012-13.csv"; 

String[] deweyClassNames = {"Arts","Civic Landscape Art", "Architecture", "Plastic Arts; Sculpture", "Drawing & Decorative Arts","Painting & Paintings","Graphic Arts; Printmaking",
                            "Photography","Music","Recreational & performing arts"};

color[][] palette = {{#DA4DFF, #CB00FF, #5F276E, #A200CC, #650080},
                     {#1AFF7A, #00A847, #00692C, #FF4134, #730800},
                     {#4CCCFF, #00B6FF, #0092CC, #26667F, #005B7F},
                   };

void setup(){
  size(1000,800);
  background(255);
  smooth();
  DeweyMap mapData = new DeweyMap();
  font = createFont("Helvetica",10,true);
  font2 = createFont("Helvetica",18,true);
 
  int[] data;
  String[] foo;
// ------------- read in Data ------------- \\ 

      String[] datum = loadStrings(dataFile);
      data = new int[datum.length];
      foo = new String[datum.length];
      for (int i = 1; i < datum.length; ++i){
         String results[] = split(datum[i],",");
         results[2] = results[2].substring(0,3);
         foo[i] = results[2];
         int a = (int)Integer.parseInt(results[0]);  //year
         int b = (int)Integer.parseInt(results[1]);  //month
         int val = (int)Float.parseFloat(results[2]);//deweyNumber
         data[i] = val;     
      }

// ------------- Create the Map ------------- \\ 
  data = sort(data);
  for (int i = 0; i < data.length; i++){
      mapData.addDewey(data[i]);
  }
  
  mapData.finishAdd();
  map = new Treemap(mapData, 0, 1.0, width, height); 
}

void draw(){
  background(255);
  map.setLayout(layoutAlgorithm);
  map.updateLayout();
  map.draw();
  noLoop();
  drawStaticText();
  totalCheckouts = 0;
  for (int i = 0; i < frequency.length; i++){
      totalCheckouts += frequency[i];
      if (frequency[i] > 0) {
        println("The Number of checkouts for Dewey Class " + i + " is " + frequency[i]);
      } 
  }
  
  println(totalCheckouts);
}

